/* -----------------------------------------------------------------------------
 K03-21 Prevadec kodovani ceske diakritiky

 Martin Sloup, A04372
 FAV, INIB-INF
 msloup@students.zcu.cz
 arcao@arcao.com
 Soubor function.h
----------------------------------------------------------------------------- */

#ifndef FUNCTION_H
#define FUNCTION_H

#include <errno.h>

#define PATH_LENGTH (65535)
#define ERR_TBL_EXIST ENOENT
#define ERR_ALLOC     ENOMEM

#ifndef NDEBUG
#define error_handler(e_code, from)  {fprintf(stderr, "Nastala chyba c. %d. Soubor %s, radek %d, funkce %s.\n", e_code, __FILE__, __LINE__, from);}
#define error_handler_ex(e_code, from, s_addit)  {fprintf(stderr, "Nastala chyba c. %d. Soubor %s, radek %d, funkce %s.\n%s", e_code, __FILE__, __LINE__, from, s_addit);}
#else
#define error_handler(e_code, from) {}
#define error_handler_ex(e_code, from, s_addit) {}
#endif

#define new_string(text, length)  { if ((text = (char *) malloc((length) * sizeof(char))) == NULL) error_handler(ERR_ALLOC, "unknown::calloc");}  

#define fgetc(f) getc(f)
#define fputc(f, c) putc(c, f)
#define fsetbuf(f, buf, length)  { new_string(buf, (length) + 1); if (buf != NULL) setvbuf(f, buf, _IOFBF, length);}
#define memfree(par)  { if (par != NULL) { free(par); par = NULL; }}


extern char *my_substr(char *text, int from, int length);
extern void my_strtr(char *text, char *oldchar, char *newchar);
extern int my_strrchr(char *text, char s_char);
extern char **my_strtok(char *text, int item_count);
extern char *trim(char *text);
extern char *lcase(char *text);
extern char *ucase(char *text);
extern void gg_sort(void *base, size_t nel, size_t width, int (*compar)(const void *, const void *));
extern void compresstable();

#endif
