#include <stdio.h>

#define char2int(ch) ((ch < 0) ? ch + 256 : ch)
#define int2char(i) ((("\x9E")[0] < 0) ? ((i > 127) ? i - 256 : i) : i)


char *chars[] = {"\x9E\x9A\xE8\xF8\xEF\x9D\xF2\xE1\xE9\xEC\xED\xFD\xF3\xFA\xF9\x8E\x8A\xC8\xD8\xCF\x8D\xD2\xC1\xC9\xCC\xCD\xDD\xD3\xDA\xD9\xA7\xD7\xF7\xDF",
								 "\xA7\xE7\x9F\xFD\xD4\x9C\xE5\xA0\x82\xD8\xA1\xEC\xA2\xA3\x85\xA6\xE6\xAC\xFC\xD2\x9B\xD5\xB5\x90\xB7\xD6\xED\xE0\xE9\xDE\xF5\x9E\xF6\xE1",
								 "\x91\xA8\x87\xA9\x83\x9F\xA4\xA0\x82\x88\xA1\x98\xA2\xA3\x96\x92\x9B\x80\x9E\x85\x86\xA5\x8F\x90\x89\x8B\x9D\x95\x97\xAC\xAD\x9E\xF6\xE1",
								 "\xBE\xB9\xE8\xF8\xEF\xBB\xF2\xE1\xE9\xEC\xED\xFD\xF3\xFA\xF9\xAE\xA9\xC8\xD8\xCF\xAB\xD2\xC1\xC9\xCC\xCD\xDD\xD3\xDA\xD9\xA7\xD7\xF7\xDF"};

char *charsets[] = {"windows-1250", "latin2", "keybcs2", "iso-8859-2", "utf-8", "unicode"};

int main(int argc, char *argv[]) {
	FILE *fp;
	int c;
	int i, x;

	int diachar_used[4][128];
	int diachar_searched[4];
	int max_searched = 0;
	int probably_charset = -1;

	int charset_is_utf8 = 0, charset_is_unicode = 0;
	int utf8_subchars = 0;
	int unicode_bom = 0; /* 0 = bigendian, 1 = littleendian */
	int unicode_chars_left = 2;
	
	if (argc < 2) {
		fprintf(stderr, "Zadejte jako parametr jmeno souboru.\n");
		exit(1);
	}
	for (i=0;i<4;i++) for (x=0;x<128;x++) diachar_used[i][x]=0; 
	for (i=0;i<4;i++) for (x=0;x<strlen(chars[i]);x++) diachar_used[i][char2int(chars[i][x]) - 128] = 1; 
	for (i=0;i<4;i++) diachar_searched[i] = 0;
//	for (i=0;i<4;i++) for (x=0;x<128;x++) printf("%d: %d\n",x + 128, diachar_used[i][x]);
//	exit(0);
	
	charset_is_utf8 = 1;
	
	unicode_chars_left = 2;
	unicode_bom = 0;
	charset_is_unicode = 0;
	
	fp = fopen(argv[1], "rb");
	while((c = fgetc(fp)) != EOF) {
		c = char2int(c);
		if (c > 127) {
			if (charset_is_utf8 == 1) {
				if (utf8_subchars == 0) {
					if (c <= 127) utf8_subchars = 1;
					else if (c >= 192 && c <= 223) utf8_subchars = 1;
					else if (c >= 224 && c <= 239) utf8_subchars = 2;
					else if (c >= 240 && c <= 247) utf8_subchars = 3;
					else charset_is_utf8 = 0;
				} else if (utf8_subchars == 1 || utf8_subchars == 2 || utf8_subchars == 3) {
					if (c >= 128 && c <= 191) utf8_subchars--;
					else charset_is_utf8 = 0;
				}
			}
			if (charset_is_unicode == 0 && unicode_chars_left > 0) {
				if (unicode_chars_left == 2) {
					if (c == 0xFE) unicode_bom = 0;
					if (c == 0xFF) unicode_bom = 1;
					unicode_chars_left--;
				} else if (unicode_chars_left == 1) {
					if (unicode_bom == 0 && c == 0xFF) charset_is_unicode = 1;
					if (unicode_bom == 1 && c == 0xFE) charset_is_unicode = 1;
					unicode_chars_left--;
					if (charset_is_unicode == 1) break;
				} 
			}
			for(i=0;i<4;i++) {
				if (diachar_used[i][c - 128] == 1) {
					diachar_searched[i] += 1;
				}
			}
		}
	}
	fclose(fp);
	
	if (charset_is_utf8 == 0 && charset_is_unicode == 0) {
		for(i=0;i<4;i++) {
			if (max_searched < diachar_searched[i]) {
				max_searched = diachar_searched[i];
				probably_charset = i;
			}
		}
	} else {
		if (charset_is_utf8 == 1) probably_charset = 4;
		if (charset_is_unicode == 1) probably_charset = 5;
	}
	
	if (probably_charset < 0) {
		fprintf(stderr, "Soubor %s ma nezname kodovani.\n", argv[1]);
	} else {
		fprintf(stderr, "Soubor %s ma ma paravdepodobne kodovani %s.\n", argv[1], charsets[probably_charset]);
	}
	return 0;
}
